<template>
  <q-form>
    <q-input
      v-model="form.query"
      dense
      filled
      label="Ingrese el nombre o documento"
    >
      <template v-slot:after>
        <q-btn
          square
          color="primary"
          icon="person_search"
          @click="buscarPersona"
        />
      </template>
    </q-input>
    <br />
    <q-markup-table dense>
      <thead>
        <tr>
          <th>Persona</th>
          <th>Acciones</th>
        </tr>
      </thead>

      <tbody>
        <tr v-for="item in dataSet" :key="item.uuid">
          <td>
            <PersonaDetalle :persona="item" />
          </td>
          <td>
            <div class="q-gutter-xs">
              <q-btn
                square
                size="sm"
                color="red"
                icon="fas os-area-ams"
                label="Formacion"
                :to="'/formacion/cursantes/detalle/' + item.uuid"
              />

              <q-btn
                square
                size="sm"
                color="primary"
                icon="person_search"
                label="Perfil"
                :to="'/membresia/personas/perfil/' + item.uuid"
              />
            </div>
          </td>
        </tr>
      </tbody>

      <div
        class="full-width text-center text-orange q-gutter-sm"
        v-if="!loading && dataSet?.length == 0"
      >
        <q-icon size="2em" name="sentiment_dissatisfied" />
        <span> No existen resultados </span>
      </div>
    </q-markup-table>
    <Loading :showing="loading" />
  </q-form>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from 'vue';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import { PersonaBasicaInterface } from 'src/interfaces/PersonasInterface';
import Loading from 'src/components/Loading.vue';
import { useQuasar } from 'quasar';
interface Form {
  query: string;
  afiliado: string;
}

export default defineComponent({
  name: 'PendientesCierrePartial',
  components: { Loading, PersonaDetalle },
  setup() {
    const $q = useQuasar();
    const loading = ref(false);
    const form = reactive<Form>({
      query: '',
      afiliado: 'S',
    });

    const dataSet = ref<PersonaBasicaInterface[]>();
    function buscarPersona() {
      if (form.query.length < 4) {
        $q.notify({
          message: 'Debe ingresar mas datos',
          type: 'negative',
          position: 'top', // right
        });
        return;
      }

      loading.value = true;
      api
        .get('/api/persona/personas/busqueda/basica?rowsPerPage=20', {
          params: form,
        })
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          if (dataSet.value?.length === 20) {
            $q.notify({
              message: 'La consulta se limito a los primeros 20 resultados',
              type: 'info',
              position: 'top', // right
            });
          }
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return { loading, dataSet, form, buscarPersona };
  },
});
</script>
